/**
  ******************************************************************************
  * @file    vk1s68c_driver.h
  * @author  kevin_guo
  * @version V1.0.0
  * @date    072-01-2019
  * @brief   This file contains all files for vk1s68c_driver.
  ******************************************************************************
  * @attention
  ******************************************************************************
  */
/* Includes ------------------------------------------------------------------*/
#include "vk1s68c_driver.h"

/* extern variables ----------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
unsigned char vk1s68c_write_buf[16];
unsigned char vk1s68c_key[5];
/* Private function prototypes -----------------------------------------------*/
/* Private function ----------------------------------------------------------*/
/*******************************************************************************
* Function Name  : VK1s68c_delay_nus
* Description    : ʱ1uS
* Input          : dur
* Output         : None
* Return         : None
*******************************************************************************/
void  VK1s68c_delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}	
/*******************************************************************************
* Function Name  :  VK1s68c_delayms
* Description    : ʱ1mS
* Input          : n->ʱʱnmS
* Output         : None
* Return         : None
*******************************************************************************/
void  VK1s68c_delayms(unsigned long int n)
{
	while(n--)
	{
		 VK1s68c_delay_nus(1000);
	}
}

//GPIO ģI2C 
/*******************************************************************************
* Function Name  : VK1s68cWrite1BytetoIC
* Description    : ʱӵͨMCULEDICд1ֽ
* Input          : data8
* Output         : None
* Return         : None
*******************************************************************************/
void VK1s68cWrite1BytetoIC(unsigned char data8)
{
	unsigned char i;
	
	VK1s68c_STB_LOW;			//֤STBΪ͵ƽ֮ǰ˿ڵ״̬
	for(i=0;i<8;i++)
	{
		VK1s68c_SLK_LOW;		//ȽCLK
		if((data8&0x01)!=0)
		{
			VK1s68c_DAT_HIGH;//Ҫ͵ݵĵλΪ1ѡDIOø
		}
		else
		{
			VK1s68c_DAT_LOW;	//Ҫ͵ݵĵλΪ0ѡDIO
		}
		VK1s68c_delay_nus(200);
		VK1s68c_SLK_HIGH;	//ʱӵ
		VK1s68c_delay_nus(200);
		data8=data8>>1;		//׼һBIT
	
	}//һֽں˳ѭ
}

/*******************************************************************************
* Function Name  : VK1s68cRead1BytefromIC
* Description    : ʱӵͨMCULEDIC1ֽ
* Input          : data8
* Output         : None
* Return         : None
*******************************************************************************/
unsigned char VK1s68cRead1BytefromIC(void)
{
	unsigned char i,k=0;//iѭkʱ

	VK1s68c_DAT_HIGH;	//ͷDIOΪ
	VK1s68c_STB_LOW;	//֤STBΪ͵ƽ֮ǰ˿ڵ״̬
	for(i=0;i<8;i++)
	{
		VK1s68c_SLK_LOW;//ȽCLK
		VK1s68c_delay_nus(200);
		k=k>>1;
		if(VK1s68c_DIO_IO==0)
		{
			k=k&0x7f;			//DIOΪ͵ƽkλ塰0λֲ
		}
		else
		{
			k=(k|0x80)&0xff;//DIOΪߵƽkλá1λֲ
		}
		VK1s68c_SLK_HIGH;	//ʱӵ
		VK1s68c_delay_nus(200);
	}//һֽں˳ѭ
	
	return(k);//ض1ֽ	
}
/*******************************************************************************
* Function Name  : Disp_AutoAdd1Addr
* Description    : õַԶһʽַ
* Input          : cmdaddr   дĵַ
*					 			 : databuf   ݻ
*                : num       дݸ
* Output         : None
* Return         : None
*******************************************************************************/
void VK1s68c_Disp_AutoAdd1Addr(unsigned char addr,unsigned char* databuf, unsigned char num)
{
	unsigned char i;//iƱҪٸֽʾ
	
	VK1s68c_STB_HIGH;//ͨѶʼǰͨѶ˿ȫʼΪ1	
	VK1s68cWrite1BytetoIC(VK1s68c_DISPMODE_4G13S);//ʾģʽΪ134λʾģʽ
	VK1s68c_STB_HIGH;//ʾģʽ󽫡STB1
	VK1s68cWrite1BytetoIC(VK1s68c_WRDTA_AUTOADD1ADDR);//òõַԶ1ʽдʾݣ
	VK1s68c_STB_HIGH;//ҪSTBá1
	VK1s68cWrite1BytetoIC(VK1s68c_STARTADDR+addr);//ʼַ
	//ַ󣬡STBΪ0Ҫʾ
	for(i=0;i<num;i++)
	{
		VK1s68cWrite1BytetoIC(*databuf++);//ʾݹУSTBһֱΪ0
	}
	VK1s68c_STB_HIGH;//еʾݺ14BYTE󣬽STBá1
	VK1s68cWrite1BytetoIC(VK1s68c_DISP_ON|VK1s68c_PDUTY_12_16);//ʾ
	VK1s68c_STB_HIGH;//ʾ󽫡STBá1
}
/*******************************************************************************
* Function Name  : VK1s68c_Disp_FixedAddr
* Description    : õ̶ַʽַ
* Input          : disa
* Output         : None
* Return         : None
*******************************************************************************/
void VK1s68c_Disp_FixedAddr(unsigned char addr, unsigned char data8)
{
	VK1s68c_STB_HIGH;//ͨѶʼǰͨѶ˿ȫʼΪ1	
	VK1s68cWrite1BytetoIC(VK1s68c_DISPMODE_4G13S);//ʾģʽΪ134λʾģʽ
	VK1s68c_STB_HIGH;//ʾģʽ󽫡STB1
	VK1s68cWrite1BytetoIC(VK1s68c_WRDTA_FIXEDADDR);//òù̶ַдʾݣ
	VK1s68c_STB_HIGH;//ҪSTBá1
	VK1s68cWrite1BytetoIC(VK1s68c_STARTADDR+addr);//ʾݶӦĵַ
	//ַ󣬡STBΪ0Ҫʾ
	VK1s68cWrite1BytetoIC(data8);//֡STB=01BYTEʾ
	VK1s68c_STB_HIGH;//ʾݺ󽫡STBá1
	VK1s68cWrite1BytetoIC(VK1s68c_DISP_ON|VK1s68c_PDUTY_12_16);//ʾ
	VK1s68c_STB_HIGH;//ʾ󽫡STBá1
}
	
/*******************************************************************************
* Function Name  : KeyScan
* Description    : ɨ,ӵֽڿʼ
* Input          : disa
* Output         : None
* Return         : None
*******************************************************************************/
unsigned char VK1s68c_KeyScan(void)
{
	unsigned char i;
	
	VK1s68c_STB_HIGH;
	VK1s68cWrite1BytetoIC(VK1s68c_CMD_READKEY);//Ϊ
	//STBΪ0ֵ
	//ļֵMCUļĴ
	//ICͺ˳ɶȶ
	for(i=0;i<5;i++)
	{
		vk1s68c_key[i]=VK1s68cRead1BytefromIC();
	}
	VK1s68c_STB_HIGH;
	
	return 0;//STBá1
}
/*******************************************************************************
* Function Name  : Vk1s68c_Init
* Description    : 1s68cʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void VK1s68c_Init(void)    
{   
	GPIO_SetMode(VK1s68c_STB_PORT, VK1s68c_STB_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1s68c_CLK_PORT, VK1s68c_CLK_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1s68c_DIO_PORT, VK1s68c_DIO_PIN, GPIO_MODE_OUTPUT);
	
	VK1s68c_STB_HIGH;                
	VK1s68c_SLK_HIGH;   
	VK1s68c_DAT_HIGH;
}  

/*******************************************************************************
* Function Name  : VK1s68c_Main
* Description    : VK1s68cԳ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void VK1s68c_Main(void)
{   
	unsigned char i,j;
	
	VK1s68c_Init();
	 
	for(i=0;i<14;i++)
	{
		vk1s68c_write_buf[i]=0x00;
	}
	VK1s68c_Disp_AutoAdd1Addr(0,vk1s68c_write_buf,14);   //ȫ
	VK1s68c_delayms(1000); 
	while(1)
	{
		for(i=0;i<14;i++)
		{
			vk1s68c_write_buf[i]=0xff;
		}
		VK1s68c_Disp_AutoAdd1Addr(0,vk1s68c_write_buf,14);   //ȫ
		VK1s68c_delayms(1000); 
		for(i=0;i<14;i++)
		{
			vk1s68c_write_buf[i]=0x00;
		}
		VK1s68c_Disp_AutoAdd1Addr(0,vk1s68c_write_buf,14);   //ȫ
		VK1s68c_delayms(1000); 
		
		for(j=0;j<14;j++)
		{
			for(i=0;i<14;i++)
			{
				vk1s68c_write_buf[i]=0x00;
			}
			vk1s68c_write_buf[j]=0xff; //ĳЩʾRAMֽڶӦһЩλΪգ޶ӦledֲʾRAM½
			VK1s68c_Disp_AutoAdd1Addr(0,vk1s68c_write_buf,14);   
			VK1s68c_delayms(500); 
		}
		for(j=0;j<8;j++)
		{
			for(i=0;i<14;i++)
			{
				vk1s68c_write_buf[i]=(1<<j); //ĳЩʾRAMֽڶӦһЩλΪգ޶ӦledֲʾRAM½
			}
			VK1s68c_Disp_AutoAdd1Addr(0,vk1s68c_write_buf,14);   
			VK1s68c_delayms(1000); 
		}
		
		__nop();
	}
}    
/************************END OF FILE****/
